// DTMNT emu PROJECT!
#define VER "0.54"

#define SPEED_OF_68K (12500000)
#define SPEED_OF_Z80 ( 3750000)

extern int waveout_size;
extern int waveout_rate;
extern int channels_on;

FILE *debug_log;

// Size of the arcade's screen
#define ARCADE_W (320)
#define ARCADE_H (224)

struct graph_mode
{
  int driver,x,y,depth;
};

// Rom loading
extern unsigned char do_int5;
extern unsigned char *rom68k,*rammem,*colmem,*coomem,*vidmem,*sprmem;
extern unsigned char *z80_mem,*sprite4,*sprite6,*tile27;

extern int layer;
extern int load_config(char *name);
extern int unload_config(char *name);
extern int gr_driver,gr_x,gr_y,gr_depth;
extern char driver_name[32][32];
extern int wait_vbl,layer;
extern int frame_skip,auto_frameskip,virtual_fps;
extern unsigned char dip[4];
extern int fit_screen;

extern int machine_init();
extern int machine_exit();
extern int machine_do_one_frame();
extern int graphics_info();
extern int machine_save_to(FILE *hand);
extern int machine_load_from(FILE *hand);
extern int machine_save(char *name);
extern int machine_load(char *name);
extern int run_timer,pause;
extern int record_playback;

extern int various_init();
extern int various_exit();
extern int various_info(int total_kilo_cycles);

extern volatile long long hz60;
extern volatile long long tenths;

extern struct graph_mode gr,actual;

extern int decode_theme_music
  (unsigned char *mem,int len,void *into,int bit);

extern int want_theme_music,do_theme_music;
extern int want_sound,do_sound;
extern int scale_theme_music;
extern int emulator_keys_off;
extern int show_fps;

extern int input_type[5][8];
extern unsigned char input[5][8];
extern int update_input();
extern int set_joy_type;
extern int redefine_input();
extern int input_update_mouse();
extern unsigned char aoo[8];
extern int work_out_sprites();

struct mescol {int r,g,b;};
extern struct mescol mescol,mes_white,mes_red,mes_blue;
extern char message[256]; extern volatile int message_count;
extern int play_theme;
extern int timerb_speed;
extern int sound_effect_count;
extern unsigned char sound_effect[64];
extern unsigned char sent_to_a0009;
extern int code_waiting_for_z80;
extern int *scode_remap;
extern int sound_init();
extern int sound_exit();

// StarScream specific start!
int aoo_readbyte(unsigned a);
void aoo_writebyte(unsigned a,unsigned v);
int aoo_readword(unsigned a);
void aoo_writeword(unsigned a,unsigned v);

// Since the memory gets byte swapped...
#define MEMB(wmem,addr) (*(wmem+((addr)^1)))
#define MEMW(wmem,addr) (*((unsigned short *)(wmem+(addr))))
#define MEML(wmem,addr) \
  ( ((unsigned long)(*((unsigned short *)( wmem+(addr)    ))) <<16) \
  | ((unsigned long)(*((unsigned short *)( wmem+((addr)+2))))     ) )
// StarScream specific end!

extern int waveout_stream_update();
extern volatile unsigned char ym2151_timers;
extern char rom_path[1024];
extern int display_scodes;
extern int gamma_correct;
extern double gamma_value;

extern int trippy_sprites;

#define SOUND_EFFECT_LIMIT (64)

int load_rom(unsigned char *into,char *filename,int skip,int expected_size);


// Input recording stuff
extern int save_input_init(char *);
extern int load_input_init(char *);
extern int saveload_input_exit();
extern int save_input();
extern int load_input();

extern int command_line_options(int argc,char **argv);

extern void *tralloc(int size);
extern int tree(void *mem);


#ifdef ALLEGRO_H
extern PALETTE game_pal;
int draw_graphics(BITMAP *bmp);
#endif

extern int sb_needs_more;
#define SBK \
 if (do_sound) waveout_stream_update();
// Put lots of these all over the place! Especially at slow bits!

#ifdef _MZ80_H_
void z80_rom_write(UINT32 a,UINT8 v,struct MemoryWriteByte *huh);
extern void z80_write(UINT32 a,UINT8 v,struct MemoryWriteByte *huh);
extern UINT8 z80_read(UINT32 a, struct MemoryReadByte *huh);
#endif
