// DTmnt emu
#include <stdio.h>
#include <stdlib.h>

// Takes the D05 rom and turns it into a 8-bit sample

int decode_theme_music(unsigned char *mem,int len,void *into,int bits)
{
  int i,count=0;
  signed short *new16=into;
  unsigned char *new8=into;

  if (mem==NULL) return 1;
  if (into==NULL) return 1;

  printf ("Decoding theme music...\n");

  count=0;
  for (i=0;i<len;i+=2)
  {
    int j,byte0,byte1,val,tmp;
    int bit[16]={0};
    int exp=0;
  
    byte0=mem[i];
    byte1=mem[i+1];
  
    val=(byte1<<8)+byte0;
    tmp=val;
  
    tmp=val;
    for (j=0;j<16;j++)
    {
      if (tmp&1) bit[j]=1; else bit[j]=0;
      tmp>>=1;
    }
  
    val=0;
    // Create a 9-bit value
    val<<=1; val+=bit[12];
    val<<=1; val+=bit[11];
    val<<=1; val+=bit[10];
    val<<=1; val+=bit[ 9];
    val<<=1; val+=bit[ 8];
    val<<=1; val+=bit[ 7];
    val<<=1; val+=bit[ 6];
    val<<=1; val+=bit[ 5];
    val<<=1; val+=bit[ 4];
    // val is now between 0x000-0x1ff - centralise it:
    val-=0x100;
  
    // Top three bits (13-15) are an exponent!
    exp=0;
    exp<<=1; exp+=bit[15];
    exp<<=1; exp+=bit[14];
    exp<<=1; exp+=bit[13];
    // exp is 0-7
    // val is currently less than 0x100 in magnitude
    val<<=exp;
    // val is currently less than 0x8000 in magnitude
    // It's 16-bit value
    if (bits==16)
    {
      new16[count]=val;
    }
    else
    {
      val>>=8;
      val+=128;
      new8[count]=val;
    }
    count++;
  }
  return 0;
}

